;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MenuSpy by kero
; draft v.2011-07-06
; http://files.rsdn.ru/42164/menuspy.zip
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;[Subprograms]
; Ingredients
; htodw
; GetWindowRect_
; GetMenuAncestor
; Minfo
; GetMenuTree
; SubClass
; CallWndProc
; OnTimer
; DlgProc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; \masm32\bin\ml /c /coff /I\masm32\include %NAME%.asm
; \masm32\bin\link /subsystem:windows /libpath:\masm32\lib %NAME%.obj rsrc.obj

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib shell32
inclib comctl32

MENUINFO struct
  cbSize            DWORD ?
  fMask             DWORD ?
  dwStyle           DWORD ?
  cyMax             DWORD ?
  hbrBack           DWORD ?
  dwContextHelpID   DWORD ?
  dwMenuData        DWORD ?
MENUINFO ends

MENUITEMINFO_ struct
  cbSize            DWORD ?
  fMask             DWORD ?
  fType             DWORD ?
  fState            DWORD ?
  wID               DWORD ?
  hSubMenu          DWORD ?
  hbmpChecked       DWORD ?
  hbmpUnchecked     DWORD ?
  dwItemData        DWORD ?
  dwTypeData        DWORD ?
  cch               DWORD ?
  hbmpItem          DWORD ? ; (absent in masm32)
MENUITEMINFO_ ends

MENUBARINFO struct          ; (absent in masm32)
  cbSize            DWORD ?
  rcBar             RECT <>
  hMenu             HMENU ?
  hwndMenu          HWND ?  ;  HWND
  fBarFocused       WORD ?  ; BOOL ?
  fFocused          WORD ?  ; BOOL ?
MENUBARINFO ends

GUITHREADINFO struct        ; (absent in masm32 v.10)
  cbSize            DWORD ?
  flags             DWORD ?
  hwndActive        HWND  ?
  hwndFocus         HWND  ?
  hwndCapture       HWND  ?
  hwndMenuOwner     HWND  ?
  hwndMoveSize      HWND  ?
  hwndCaret         HWND  ?
  rcCaret           RECT <>
GUITHREADINFO ends

;DRAWITEMSTRUCT struct
;  CtlType           DWORD ?
;  CtlID             DWORD ?
;  itemID            DWORD ?
;  itemAction        DWORD ?
;  itemState         DWORD ?
;  hwndItem          DWORD ? ;  HWND
;  hdc               DWORD ?
;  rcItem            RECT <>
;  itemData          DWORD ?
;DRAWITEMSTRUCT ends

;MEASUREITEMSTRUCT struct
;  CtlType           DWORD ?
;  CtlID             DWORD ?
;  itemID            DWORD ?
;  itemWidth         DWORD ?
;  itemHeight        DWORD ?
;  itemData          DWORD ?
;MEASUREITEMSTRUCT ends

.const
; 
 id                          equ  100
;
 DWMWA_NCRENDERING_ENABLED   equ  1
 DWMWA_EXTENDED_FRAME_BOUNDS equ  9
;
 WM_SYSTIMER                 equ  0118h
 WM_SYSMENU                  equ  0313h
;
 MN_SETHMENU                 equ  01E0h   ; #32768 ; msg
 MN_GETHMENU                 equ  01E1h
 MN_SIZEWINDOW               equ  01E2h
 MN_OPENHIERARCHY            equ  01E3h
 MN_CLOSEHIERARCHY           equ  01E4h
 MN_SELECTITEM               equ  01E5h
 MN_CANCELMENUS              equ  01E6h
 MN_SELECTFIRSTVALIDITEM     equ  01E7h
 MN_GETPOPUPMENU             equ  01EAh
 MN_FINDMENUWINDOWFROMPOINT  equ  01EBh
 MN_SHOWPOPUPWINDOW          equ  01ECh
 MN_BUTTONDOWN               equ  01EDh
 MN_MOUSEMOVE                equ  01EEh
 MN_BUTTONUP                 equ  01EFh
 MN_SETTIMERTOOPENHIERARCHY  equ  01F0h
 MN_DBLCLK                   equ  01F1h
 MN_ENDMENU                  equ  01F2h
 MN_DODRAGDROP               equ  01F3h
; 
 HBMMENU_CALLBACK            equ -1
 HBMMENU_SYSTEM              equ  1
 HBMMENU_MBAR_RESTORE        equ  2
 HBMMENU_MBAR_MINIMIZE       equ  3
 HBMMENU_MBAR_CLOSE          equ  5 
 HBMMENU_MBAR_CLOSE_D        equ  6
 HBMMENU_MBAR_MINIMIZE_D     equ  7
 HBMMENU_POPUP_CLOSE         equ  8
 HBMMENU_POPUP_RESTORE       equ  9
 HBMMENU_POPUP_MAXIMIZE      equ 10
 HBMMENU_POPUP_MINIMIZE      equ 11
;
.data

 _app       db "MenuSpy  by  kero   (v 2011-07-06)",0
 _exe       db "ExtantMenu.exe",0
 _extmenu   db "ExtantMenu",0
 _Dwmapi    db "Dwmapi",0
 _DwmGWA    db "DwmGetWindowAttribute",0
 _DwmICE    db "DwmIsCompositionEnabled",0
 _timer     db "+timer",0
 _hook      db "+hook",0
 _tree      db "+tree",0
 _edit      db "edit",0
 _child     db " -> child",0

 _frmt0     db " point:          %d,%d",13,10,13,10
            db " hmenubar:",13,10
            db " hmenupopup:",13,10
            db " hmenusys:",13,10
            db " style/mns_:",13,10
            db " cymax:",13,10
            db " hbrback:",13,10
            db " helpid:",13,10
            db " menudata:",13,10
            db " items:",13,10
            db " item pos:",13,10
            db " item id:",13,10
            db " item hsubmenu:",13,10
            db " item state/mf_:",13,10
            db " item hbmp:",13,10
            db " item text:",13,10
            db " item rect:",13,10
            db " hwnd rect:      [%d,%d, %d*%d]",13,10
            db " hwnd:%19.8lX  ""%s""%s",13,10
            db " tid/pid:        %d/%d",13,10
            db " flags/gui_:%13.8lX /%s",13,10
            db " hwnd menuowner:%9.8lX  ""%s""",13,10
            db " hwnd owner:%13.8lX  ""%s""",13,10,13,10,0
            
 _mii       db " item id:%12.4lX.%4.4lX/%d",13,10
            db " item hsubmenu:%6.4lX.%4.4lX/%d",13,10
            db " item state/mf_:%9.8lX /%s",13,10
            db " item hbmp:%14.8lX %s",13,10
            db " item text:      ""%s""",13,10
            db " item rect:      [%d,%d, %d*%d]",13,10,0

 _mi        db " style/mns_:%13.8lX /%s",13,10
            db " cymax:          %d",13,10
            db " hbrback:%16.8lX",13,10
            db " helpid:         %d",13,10
            db " menudata:%15.8lX",13,10,0

 _frmt      db " point:          %d,%d",13,10,13,10
            db " hmenubar:%11.4lX.%4.4lX/%d",13,10
            db " hmenupopup:%9.4lX.%4.4lX/%d",13,10
            db " hmenusys:%11.4lX.%4.4lX/%d",13,10
            db "%s"
            db " items:          %d",13,10
            db " item pos:       %d",13,10
            db "%s"
            db " hwnd rect:      [%d,%d, %d*%d]",13,10
            db " hwnd:%19.8lX  ""%s""%s",13,10
            db " tid/pid:        %d/%d",13,10
            db " flags/gui_:%13.8lX /%s",13,10
            db " hwnd menuowner:%9.8lX  ""%s""",13,10
            db " hwnd owner:%13.8lX  ""%s""",13,10,13,10,0 
            
 _cwp       db "%4.4lX%10.8lX%9.8lX %d%10.8lX",0
 _dd        db "%d (%d)",0
;                level  hmenu  count  pos   id   hmenusub   state   text
 _snap      db " %2.d  %4.4lX.%4.4lX  %2.d  %2.d   %4.4lX.%4.4lX  %4.4lX.%4.4lX  %8.8lX  ""%s""",13,10,0
 _X         db "%8.8lX",0
  alpha     dd  200

; mf0_       dd  MF_ENABLED           ; 0000h  ; 
;            dd  MF_UNCHECKED         ; 0000h  ;
;            dd  MF_UNHILITE          ; 0000h  ;
;            dd  MF_BYCOMMAND         ; 0000h  ;
;            dd  MF_STRING            ; 0000h  ;
 mf_        dd  MF_GRAYED            ; 0001h        ; n=16 ; <old MENUITEMINFO>
            dd  MF_DISABLED          ; 0002h
            dd  MF_BITMAP            ; 0004h 
            dd  MF_CHECKED           ; 0008h
            dd  MF_POPUP             ; 0010h
            dd  MF_MENUBARBREAK      ; 0020h
            dd  MF_MENUBREAK         ; 0040h 
            dd  MF_HILITE            ; 0080h
            dd  MF_OWNERDRAW         ; 0100h  ; _APPEND
            dd  MF_USECHECKBITMAPS   ; 0200h  ; _DELETE
            dd  MF_BYPOSITION        ; 0400h
            dd  MF_SEPARATOR         ; 0800h
            dd  MF_DEFAULT           ; 1000h  ; _REMOVE
            dd  MF_SYSMENU           ; 2000h
            dd  MF_HELP              ; 4000h  ; _RIGHTJUSTIFY
            dd  MF_MOUSESELECT       ; 8000h

; _mf0       db " enabled",0
;            db " unchecked",0
;            db " unhilite",0
;            db " bycommand",0
;            db " string",0
 _mf        db " grayed",0
            db " disabled",0
            db " bitmap",0
            db " checked",0
            db " popup",0
            db " menubarbreak",0
            db " menubreak",0
            db " hilite",0
            db " ownerdraw",0        ; _APPEND
            db " usecheckbitmaps",0  ; _DELETE
            db " byposition",0
            db " separator",0
            db " default",0          ; _REMOVE
            db " sysmenu",0
            db " help",0             ; _RIGHTJUSTIFY
            db " mouseselect",0

  mns_      dd  MNS_NOCHECK           ; 80000000h   ; n=6 ; MENUINFO
            dd  MNS_MODELESS          ; 40000000h
            dd  MNS_DRAGDROP          ; 20000000h
            dd  MNS_AUTODISMISS       ; 10000000h
            dd  MNS_NOTIFYBYPOS       ; 08000000h
            dd  MNS_CHECKORBMP        ; 04000000h

 _mns       db " nocheck",0
            db " modeless",0
            db " dragdrop",0
            db " autodismiss",0
            db " notifybypos",0
            db " checkorbmp",0

  gui_      dd  GUI_CARETBLINKING     ; 1           ; n=5 ; GUITHREADINFO
            dd  GUI_INMOVESIZE        ; 2
            dd  GUI_INMENUMODE        ; 4
            dd  GUI_SYSTEMMENUMODE    ; 8
            dd  GUI_POPUPMENUMODE     ; 10h

  _gui      db " caretblinking",0
            db " inmovesize",0
            db " inmenumode",0
            db " systemmenumode",0
            db " popupmenumode",0

 _hbm_m1    db "'drawn_by_menuowner_window'",0   ; (=> WM_MEASUREITEM, WM_DRAWITEM)
 _hbm_1     db "'icon'",0    ; (Windows icon or the icon of the window specified in dwItemData)
 _hbm_2     db "'menubar restore button'",0
 _hbm_3     db "'menubar minimize button'",0
 _hbm_5     db "'menubar close button'",0
 _hbm_6     db "'menubar disabled close button'",0
 _hbm_7     db "'menubar disabled minimize button'",0
 _hbm_8     db "'popupmenu close button'",0
 _hbm_9     db "'popupmenu restore button'",0
 _hbm_10    db "'popupmenu maximize button'",0
 _hbm_11    db "'popupmenu minimize button'",0

 _msgs      db "002B  WM_DRAWITEM",13,10
            db "002C  WM_MEASUREITEM",13,10
            db "007B  WM_CONTEXTMENU",13,10
            db "0090  ?",13,10
            db "0091  WM_UAHDRAWMENU",13,10
            db "0092  WM_UAHDRAWMENUITEM",13,10
            db "0093  WM_UAHINITMENU",13,10
            db "0094  WM_UAHMEASUREMENUITEM",13,10
            db "0095  WM_UAHNCPAINTMENUPOPUP",13,10
            db "0112  WM_SYSCOMMAND",13,10
            db "0116  WM_INITMENU",13,10
            db "0117  WM_INITMENUPOPUP",13,10
            db "0118  WM_SYSTIMER",13,10
            db "011F  WM_MENUSELECT",13,10
            db "0120  WM_MENUCHAR",13,10
            db "0121  WM_ENTERIDLE",13,10
            db "0122  WM_MENURBUTTONUP",13,10
            db "0123  WM_MENUDRAG",13,10
            db "0124  WM_MENUGETOBJECT",13,10
            db "0125  WM_UNINITMENUPOPUP",13,10
            db "0126  WM_MENUCOMMAND",13,10
            db "01E0  MN_SETHMENU",13,10
            db "01E1  MN_GETHMENU",13,10
            db "01E2  MN_SIZEWINDOW",13,10
            db "01E3  MN_OPENHIERARCHY",13,10
            db "01E4  MN_CLOSEHIERARCHY",13,10
            db "01E5  MN_SELECTITEM",13,10
            db "01E6  MN_CANCELMENUS",13,10
            db "01E7  MN_SELECTFIRSTVALIDITEM",13,10
            db "01EA  MN_GETPOPUPMENU",13,10
            db "01EB  MN_FINDMENUWINDOWFROMPOINT",13,10
            db "01EC  MN_SHOWPOPUPWINDOW",13,10
            db "01ED  MN_BUTTONDOWN",13,10
            db "01EE  MN_MOUSEMOVE",13,10
            db "01EF  MN_BUTTONUP",13,10
            db "01F0  MN_SETTIMERTOOPENHIERARCHY",13,10
            db "01F1  MN_DBLCLK",13,10
            db "01F2  MN_ENDMENU",13,10
            db "01F3  MN_DODRAGDROP",13,10
            db "0211  WM_ENTERMENULOOP",13,10
            db "0212  WM_EXITMENULOOP",13,10
            db "0213  WM_NEXTMENU",13,10
            db "0230  WM_MDISETMENU",13,10
            db "0234  WM_MDIREFRESHMENU",13,10
            db "0313  WM_SYSMENU (WM_TASKBUTTONMENU)",0

.data?
  hinst        HINSTANCE ?
  hwcb         HWND ?
  hmenu        HMENU ?
  hkcwp        dd ?
  menutree     dd ?   ; (0 --> menu branch, 1 --> menu tree)
  width_delta  dd ?
  count        dd ?
  enteridle    dd ?
  tmflag       dd ?
  oldbuf       db MAX_PATH dup(?)
  buffer       db 10000h dup(?)

.code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Ingredients proc uses ebx edi esi lpvals:DWORD,lpnames:DWORD,lenght:DWORD,sumval:DWORD,lpout:DWORD

  mov ebx,lenght
  mov edi,lpvals
  mov esi,lpnames
@1:
  test ebx,ebx
  jz @2
  mov eax,dword ptr[edi]
  mov ecx,sumval
  mov edx,ecx
  or ecx,eax
  cmp ecx,edx
  jnz @f
  invoke lstrcat,lpout,esi
@@:
  invoke lstrlen,esi
  add esi,eax
  inc esi
  add edi,4
  dec ebx
  jmp @1
@2:
  ret
Ingredients endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; (From: masm32\m32lib\htodw.asm)

htodw proc String:DWORD

; -----------------------------------
; Convert hex string into dword value
; Return value in eax
; -----------------------------------
    push ebx
    push esi
    push edi
    mov edi, String
    mov esi, String 
     ALIGN 4
  again:  
    mov al,[edi]
    inc edi
    or  al,al
    jnz again
    sub esi,edi
    xor ebx,ebx
    add edi,esi
    xor edx,edx
    not esi             ;esi = lenth
  .while esi != 0
    mov al, [edi]
    cmp al,'A'
    jb figure
    sub al,'a'-10
    adc dl,0
    shl dl,5            ;if cf set we get it bl 20h else - 0
    add al,dl
    jmp next
  figure: 
    sub al,'0'
  next:  
    lea ecx,[esi-1]
    and eax, 0Fh
    shl ecx,2           ;mul ecx by log 16(2)
    shl eax,cl          ;eax * 2^ecx
    add ebx, eax
    inc edi
    dec esi
  .endw
    mov eax,ebx
    pop edi
    pop esi
    pop ebx
    ret
htodw endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; instead of GetWindowRect
; for Vista/Win7/...

GetWindowRect_ proc uses ebx hWnd:HWND, lprect:DWORD

  local var:DWORD
  
  invoke GetModuleHandle,offset _Dwmapi
  test eax,eax
  jz @f
  mov ebx,eax
  invoke GetProcAddress,ebx,offset _DwmICE
  test eax,eax
  jz @f
  lea edx,var
  push edx
  call eax
  cmp eax,S_OK
  jnz @f
  mov eax,var
  test eax,eax
  jz @f
  invoke GetProcAddress,ebx,offset _DwmGWA
  test eax,eax
  jz @f
  push sizeof RECT
  push lprect
  push DWMWA_EXTENDED_FRAME_BOUNDS
  push hWnd
  call eax
  cmp eax,S_OK
  jz @@@
@@:
  invoke GetWindowRect,hWnd,lprect
@@@:
  ret
GetWindowRect_ endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; param==0  -->       owner menu  (level-1)
; param!=0  -->  root owner menu  (level=0)

GetMenuAncestor proc uses ebx edi esi hMenu:DWORD, param:DWORD

  mov ebx,hMenu
@1:
  xor edi,edi
  .while edi<0FFFFFFh
    invoke IsMenu,edi
    .if eax!=0 && edi!=ebx
      xor esi,esi
      .while TRUE
        invoke GetMenuItemID,edi,esi
        push eax      
        invoke GetSubMenu,edi,esi
        pop edx
        .if ax==bx
          jmp @2
        .elseif eax==0 && edx==-1
          jmp @f
        .endif
        inc esi
      .endw
    .endif
@@:
    inc edi
  .endw
@2:
  .if edi!=0FFFFFFh
    .if param!=0
      mov ebx,edi
      jmp @1
    .else
      mov eax,edi
    .endif
  .else  
    mov eax,ebx
  .endif
  push eax
  invoke GetMenuItemCount,eax
  mov edx,eax                  ; count
  mov ecx,esi                  ; pos
  pop eax                      ; hmenu  
  ret
GetMenuAncestor endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Minfo proc uses ebx edi esi hMenu:HMENU, menulevel:DWORD, menupos:DWORD, hMenuStart:HMENU, posStart:DWORD, lpbuf:DWORD

  local var1:DWORD
  local var2:DWORD
  local var3:DWORD
  local var4:DWORD
  local var5:DWORD
  local var6:DWORD
  local var7:DWORD
  local buf[1024]:BYTE
  local bu[128]:BYTE
  
  mov eax,hMenu
  mov edx,eax
  and eax,0ffffh
  mov var6,eax
  shr edx,16
  mov var7,edx
  
  invoke GetMenuItemCount,hMenu
  mov edi,eax
  
  invoke GetMenuItemID,hMenu,menupos
  mov esi,eax
  mov edx,eax
  and eax,0ffffh
  mov var2,eax
  shr edx,16
  mov var3,edx
  
  invoke GetSubMenu,hMenu,menupos
  mov ebx,eax
  mov edx,eax
  and eax,0ffffh
  mov var4,eax
  shr edx,16
  mov var5,edx
  
  invoke GetMenuState,hMenu,menupos,MF_BYPOSITION
  mov var1,eax
  invoke GetMenuString,hMenu,menupos,addr bu,127,MF_BYPOSITION
  
  invoke wsprintf,addr buf,offset _snap,menulevel,var7,var6,edi,menupos,var3,var2,var5,var4,var1,addr bu

  mov eax,hMenu
  mov ecx,hMenuStart
  mov edx,menupos
  .if ax==cx && edx==posStart
    mov byte ptr[buf],'>'
  .endif
  invoke lstrcat,lpbuf,addr buf

  mov edx,edi  ; count
  mov ecx,esi  ; id
  mov eax,ebx  ; hsubmenu
  ret
Minfo endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetMenuTree proc uses ebx edi esi hMenuStart:HMENU, posStart:DWORD, lpbuf:DWORD,treebranch:DWORD

  local menupos:DWORD
  
  mov edi,hMenuStart
  invoke IsMenu,edi
  .if eax==0
@@:
    invoke Beep,6000,100
  .else
    .if treebranch!=0
      invoke GetMenuAncestor,edi,1
      mov edi,eax
    .endif
    mov eax,edi      ; root hmenu
    xor esi,esi
    dec esi
@inc:
    inc esi
    xor ecx,ecx
    mov menupos,ecx
@0:
    mov ebx,eax
    invoke IsMenu,ebx
    .if eax==0
      jmp @b
    .endif
    invoke Minfo,ebx,esi,menupos,hMenuStart,posStart,lpbuf
    test eax,eax
    jnz @inc
@dec:
    inc menupos
    .if menupos<edx  ; count
      mov eax,ebx    ; next item
      jmp @0
    .endif
    mov eax,edi
    .if bx!=ax
      invoke GetMenuAncestor,ebx,0
      mov ebx,eax
      mov menupos,ecx      
      dec esi
      jmp @dec
    .endif
  .endif
  ret
GetMenuTree endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubClass proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

  .if uMsg==MN_BUTTONDOWN
    invoke Beep,5000,100
  .elseif uMsg==MN_BUTTONUP
    invoke Beep,6000,100
  .endif
  invoke GetWindowLong,hWnd,GWL_USERDATA
  invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  ret
SubClass endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CallWndProc proc uses ebx edi nCode:UINT, wParam:WPARAM, lParam:LPARAM

  local mii:MENUITEMINFO
  local buf[MAX_PATH]:BYTE
  
  .if nCode==HC_ACTION
    mov ebx,lParam
    assume ebx:PTR CWPSTRUCT

    inc count
    invoke GetClassLong,[ebx].hwnd,GCW_ATOM
    .if eax==8000h
      invoke wsprintf,addr buf,offset _cwp,[ebx].message,[ebx].wParam,[ebx].lParam,wParam,[ebx].hwnd
      invoke lstrcmpi,addr buf,addr oldbuf
      .if eax!=0
        invoke lstrcpy,addr oldbuf,addr buf
        invoke SendMessage,hwcb,CB_ADDSTRING,0,addr buf
        invoke SendMessage,hwcb,CB_GETCOUNT,0,0
        invoke wsprintf,addr buf,offset _dd,eax,count
        invoke SetWindowText,hwcb,addr buf
      .endif
      
      invoke SendMessage,[ebx].hwnd,MN_GETHMENU,0,0
      .if eax!=0
        mov edi,eax
        mov mii.cbSize,sizeof MENUITEMINFO
        mov mii.fMask,MIIM_FTYPE
        invoke GetMenuItemInfo,edi,0,TRUE,addr mii
        mov eax,mii.fType
        mov edx,eax
        or edx,MFT_MENUBREAK
        .if eax!=edx
          mov mii.fType,MFT_MENUBREAK
          invoke SetMenuItemInfo,edi,0,TRUE,addr mii
        .endif
      .endif
      
      .if [ebx].message==MN_SELECTITEM
        invoke GetWindowLong,[ebx].hwnd,GWL_USERDATA
        .if eax==0
          invoke SetWindowLong,[ebx].hwnd,GWL_WNDPROC,addr SubClass
          invoke SetWindowLong,[ebx].hwnd,GWL_USERDATA,eax
        .endif
      .endif
    .endif

    .if [ebx].message==WM_ENTERIDLE && [ebx].wParam==MSGF_MENU
      invoke GetWindowLong,[ebx].lParam,GWL_EXSTYLE
      mov edx,eax
      or eax,WS_EX_LAYERED
      .if eax!=edx
        and eax,not (WS_EX_TOOLWINDOW or WS_EX_DLGMODALFRAME)
        or eax,WS_EX_CLIENTEDGE
        invoke SetWindowLong,[ebx].lParam,GWL_EXSTYLE,eax
;        invoke SetWindowPos,[ebx].lParam,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
        invoke SetLayeredWindowAttributes,[ebx].lParam,0,alpha,LWA_ALPHA
        invoke GetWindowLong,[ebx].lParam,GWL_STYLE
        or eax,WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_THICKFRAME
        invoke SetWindowLong,[ebx].lParam,GWL_STYLE,eax
;        invoke SetWindowPos,[ebx].lParam,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
      .endif
    .endif
    assume ebx:nothing    
  .endif
  invoke CallNextHookEx,hkcwp,nCode,wParam,lParam
  ret
CallWndProc endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

OnTimer proc uses ebx edi esi hWnd:HWND

  local pt:POINT
  local rt:RECT
  local rc:RECT
  local mbi:MENUBARINFO    
  local mi:MENUINFO
  local mii:MENUITEMINFO_
  local guiti:GUITHREADINFO  
  local state:DWORD
  local hwown:DWORD
  local var1:DWORD
  local var2:DWORD
  local var3:DWORD
  local var4:DWORD
  local var5:DWORD
  local var6:DWORD
  local var7:DWORD
  local var8:DWORD
  local var9:DWORD
  local var10:DWORD
  local chld:DWORD
  local tid:DWORD  
  local pid:DWORD  
  local buff[1024]:BYTE
  local bu1[64]:BYTE
  local bu2[64]:BYTE
  local bu3[64]:BYTE
  local bu4[64]:BYTE
  local bu5[16]:BYTE  
  local bu6[32]:BYTE  
  local buf_mi[256]:BYTE
  local buf_mi_style[256]:BYTE  
  local buf_mii[256]:BYTE
  local buf_guiti[256]:BYTE
  local buf_mii_state[128]:BYTE
  
  xor eax,eax
  mov byte ptr buffer,al
  mov byte ptr buff,al
  mov byte ptr bu1,al
  mov byte ptr bu2,al
  mov byte ptr bu3,al
  mov byte ptr bu4,al
  mov byte ptr bu5,al
  mov byte ptr buf_mi,al    
  mov byte ptr buf_mi_style,al
  mov byte ptr buf_mii,al  
  mov byte ptr buf_mii_state,al
  mov byte ptr buf_guiti,al
  mov chld,eax

  invoke GetCursorPos,addr pt
  invoke WindowFromPoint,pt.x,pt.y
  mov ebx,eax

  invoke GetClassName,ebx,addr bu1,63
  invoke GetWindowLong,ebx,GWL_STYLE
  test eax,WS_CHILD
  jz @f
  invoke lstrcpy,addr bu5,offset _child
  inc chld
@@:
  invoke GetWindowRect_,ebx,addr rc
  mov eax,rc.left
  sub rc.right,eax
  mov eax,rc.top
  sub rc.bottom,eax

  invoke GetWindow,ebx,GW_OWNER
  mov hwown,eax
  invoke GetClassName,hwown,addr bu3,63
  
  invoke GetWindowThreadProcessId,ebx,addr pid
  mov tid,eax
  mov guiti.cbSize,sizeof guiti
  invoke GetGUIThreadInfo,tid,addr guiti    
  xor eax,eax
  mov byte ptr [buf_guiti],al
  invoke Ingredients,offset gui_,offset _gui,5,guiti.flags,addr buf_guiti

  invoke GetClassName,guiti.hwndMenuOwner,addr bu4,63

  invoke GetSystemMenu,ebx,FALSE
;  mov hmenusys,eax
  push eax
  mov ecx,eax
  and eax,0ffffh
  mov var4,eax
  shr ecx,16
  mov var5,ecx

  invoke SendMessage,ebx,MN_GETHMENU,0,0
;  mov hmenupopup,eax
  push eax
  mov ecx,eax
  and eax,0ffffh
  mov var6,eax
  shr ecx,16
  mov var7,ecx

  invoke GetMenu,ebx
;  mov hmenubar,eax
  push eax
  mov ecx,eax
  and eax,0ffffh
  mov var1,eax
  shr ecx,16
  mov var3,ecx

  pop edi
  invoke IsMenu,edi
  .if eax!=0 && chld==0
    pop eax
    pop eax
  .else
    pop edi
    invoke IsMenu,edi
    .if eax!=0
      pop eax
    .else
      pop edi
      invoke IsMenu,edi
      .if eax==0
        mov edi,eax
      .endif
    .endif
  .endif
;;
;; 
  .if edi==0
    invoke wsprintf,addr buff,offset _frmt0,
      pt.x,pt.y,
      rc.left,rc.top,rc.right,rc.bottom,
      ebx,addr bu1,addr bu5,
      tid,pid,
      guiti.flags,addr buf_guiti,
      guiti.hwndMenuOwner,addr bu4,      
      hwown,addr bu3
  .else
    invoke MenuItemFromPoint,ebx,edi,pt.x,pt.y
    mov esi,eax
    invoke GetMenuString,edi,esi,addr bu2,63,MF_BYPOSITION
    
    invoke GetKeyState,VK_F12
    and eax,8000h
    .if eax!=0
      mov eax,chld
      test eax,eax
      jnz @f
      invoke GetMenuTree,edi,esi,addr buffer,menutree
      invoke SetDlgItemText,hWnd,id+4,addr buffer
@@:
      invoke Beep,6000,100
    .endif

    invoke GetKeyState,VK_F11
    and eax,8000h
    .if eax!=0 && edi!=0
      invoke Sleep,100
      invoke GetMenuState,edi,esi,MF_BYPOSITION    
      and eax,(MF_DISABLED or MF_GRAYED)
      .if eax!=0
        mov edx,MF_BYPOSITION or MF_ENABLED
      .else
        mov edx,MF_BYPOSITION or MF_DISABLED or MF_GRAYED
      .endif
      invoke EnableMenuItem,edi,esi,edx
    .endif
    
    invoke GetMenuState,edi,esi,MF_BYPOSITION    
    mov state,eax
    cmp eax,0ffffffffh
    jz @f
    invoke Ingredients,offset mf_,offset _mf,16,state,addr buf_mii_state
@@:  
    invoke GetSubMenu,edi,esi
    mov ecx,eax
    and eax,0ffffh
    mov var8,eax
    shr ecx,16
    mov var9,ecx
  
    invoke GetMenuItemID,edi,esi
    mov edx,eax
    and eax,0ffffh
    mov var2,eax
    shr edx,16
    mov var10,edx
  
    invoke GetMenuItemRect,ebx,edi,esi,addr rt
    mov eax,rt.left
    sub rt.right,eax
    mov eax,rt.top
    sub rt.bottom,eax

    mov mbi.cbSize,sizeof mbi
    invoke GetMenuBarInfo,ebx,OBJID_MENU,0,addr mbi
    .if eax!=0 && esi>=80000000h
      mov eax,mbi.rcBar.left
      mov rt.left,eax
      mov ecx,mbi.rcBar.right
      sub ecx,eax
      mov rt.right,ecx
      mov eax,mbi.rcBar.top
      mov rt.top,eax
      mov ecx,mbi.rcBar.bottom
      sub ecx,eax
      mov rt.bottom,ecx
    .endif
    
    mov mi.cbSize,sizeof mi
    mov mi.fMask,MIM_STYLE or MIM_MENUDATA or MIM_HELPID or MIM_MAXHEIGHT or MIM_BACKGROUND or MIM_APPLYTOSUBMENUS
    invoke GetMenuInfo,edi,addr mi
    invoke Ingredients,offset mns_,offset _mns,6,mi.dwStyle,addr buf_mi_style

    invoke wsprintf,addr buf_mi,offset _mi,
      mi.dwStyle,addr buf_mi_style,
      mi.cyMax,
      mi.hbrBack,
      mi.dwContextHelpID,
      mi.dwMenuData

    mov mii.cbSize,sizeof mii
    mov mii.fMask,MIIM_BITMAP
    invoke GetMenuItemInfo,edi,esi,TRUE,addr mii
    mov eax,mii.hbmpItem
    xor ecx,ecx
    .if esi<80000000h
      .if eax==-1
        mov ecx,offset _hbm_m1
      .elseif eax==1
        mov ecx,offset _hbm_1
      .elseif eax==2
        mov ecx,offset _hbm_2
      .elseif eax==3
        mov ecx,offset _hbm_3
      .elseif eax==5
        mov ecx,offset _hbm_5
      .elseif eax==6
        mov ecx,offset _hbm_6
      .elseif eax==7
        mov ecx,offset _hbm_7
      .elseif eax==8
        mov ecx,offset _hbm_8
      .elseif eax==9
        mov ecx,offset _hbm_9
      .elseif eax==10
        mov ecx,offset _hbm_10
      .elseif eax==11
        mov ecx,offset _hbm_11
      .endif
    .endif

    .if var2==0FFFFh
      mov edx,-1
    .else
      mov edx,var2
    .endif

    invoke wsprintf,addr buf_mii,offset _mii,
      var10,var2,edx,
      var9,var8,var8,
      state,addr buf_mii_state,
      mii.hbmpItem,ecx,
      addr bu2,
      rt.left,rt.top,rt.right,rt.bottom

    invoke GetMenuItemCount,edi
    mov ecx,eax

    invoke wsprintf,addr buff,offset _frmt,
      pt.x,pt.y,
      var3,var1,var1,
      var7,var6,var6,
      var5,var4,var4,
      addr buf_mi,
      ecx,
      esi,
      addr buf_mii,
      rc.left,rc.top,rc.right,rc.bottom,
      ebx,addr bu1,addr bu5,
      tid,pid,
      guiti.flags,addr buf_guiti,
      guiti.hwndMenuOwner,addr bu4,
      hwown,addr bu3
      
  .endif
;;
;;
  mov byte ptr buffer,0  
  invoke GetDlgItemText,hWnd,id+1,addr buffer,1023
  invoke lstrcmp,addr buff,addr buffer
  .if eax!=0
    invoke SetDlgItemText,hWnd,id+1,addr buff
  .endif

  ret
OnTimer endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DlgProc proc uses ebx edi esi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

  local rt:RECT
  local mii:MENUITEMINFO
  local buf[9]:BYTE

  .if uMsg==WM_CLOSE
    invoke KillTimer,hWnd,id
    .if hkcwp!=0
      invoke UnhookWindowsHookEx,hkcwp
    .endif
    invoke EndDialog,hWnd,0
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_CTLCOLORSTATIC || uMsg==WM_CTLCOLORDLG
    invoke GetStockObject,WHITE_BRUSH
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_NCHITTEST
    mov ecx,lParam
    mov edx,ecx
    and ecx,0ffffh
    shr edx,16
    invoke MenuItemFromPoint,hWnd,hmenu,ecx,edx
    mov ebx,eax
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    .if eax==HTCLIENT
      mov eax,HTCAPTION
    .elseif eax==HTMENU && ebx==-1
      mov eax,HTCAPTION    
    .endif
    invoke SetWindowLong,hWnd,DWL_MSGRESULT,eax
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_TIMER
    invoke OnTimer,hWnd
    mov eax,TRUE
;-------------------------------------------------------------------------------------\
	.elseif uMsg==WM_NCLBUTTONDBLCLK && wParam==HTCAPTION
    invoke GetMenu,hWnd
    .if eax!=0
      invoke SetMenu,hWnd,0
      xor eax,eax
    .else
      mov eax,hmenu
    .endif
    invoke SetMenu,hWnd,eax
    mov eax,TRUE
;-------------------------------------------------------------------------------------
	.elseif uMsg==WM_NCRBUTTONUP
    invoke SendMessage,hWnd,WM_SYSMENU,0,lParam
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_INITDIALOG
    invoke SetWindowText,hWnd,offset _app
    invoke GetMenu,hWnd
    mov hmenu,eax
    invoke SetDlgItemText,hWnd,id+2,offset _msgs
    invoke GetDlgItem,hWnd,id+3
    mov hwcb,eax
    invoke GetSystemMenu,hWnd,0
    mov ebx,eax
    mov mii.cbSize,sizeof MENUITEMINFO
    mov mii.fMask,MIIM_FTYPE
    invoke GetMenuItemInfo,ebx,0,TRUE,addr mii
    mov mii.fType,MFT_MENUBREAK
    invoke SetMenuItemInfo,ebx,0,TRUE,addr mii
    invoke GetClientRect,hWnd,addr rt
    mov edi,rt.right
    invoke GetDlgItem,hWnd,id+4
    mov ebx,eax
    invoke GetWindowRect_,ebx,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    sub edi,rt.right
    mov width_delta,edi
    invoke SetTimer,hWnd,id,100,0
    inc tmflag
;    inc menutree
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_COMMAND && wParam==id-2 && lParam==0        ; 'hook'
@@:
    mov ebx,offset _hook
    mov edi,id-2
    .if hkcwp!=0
      invoke UnhookWindowsHookEx,hkcwp
      xor eax,eax
      mov hkcwp,eax
      mov al,'-'    
    .else
      invoke GetCurrentThreadId
      invoke SetWindowsHookEx,WH_CALLWNDPROC,offset CallWndProc,0,eax
      mov hkcwp,eax
      mov al,'+'
    .endif
    jmp @f
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_COMMAND && wParam==id-1 && lParam==0        ; 'timer'
    mov ebx,offset _timer
    mov edi,id-1
    xor tmflag,1
    .if tmflag==0
      invoke KillTimer,hWnd,id
      mov al,'-'
    .else
;      invoke SetDlgItemText,hWnd,id+4,0
      invoke SetTimer,hWnd,id,100,0
      mov al,'+'
    .endif
@@:
    mov byte ptr[ebx],al
    invoke GetMenu,hWnd
    mov esi,eax
    invoke ModifyMenu,esi,edi,MF_BYCOMMAND or MF_STRING,edi,ebx
    invoke DrawMenuBar,hWnd
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_COMMAND && wParam==id-3 && lParam==0        ; 'clear'
    xor ebx,ebx
    mov count,ebx
    mov enteridle,ebx
    invoke SendDlgItemMessage,hWnd,id+3,CB_RESETCONTENT,ebx,ebx
    invoke SetDlgItemText,hWnd,id+4,ebx
    invoke SetDlgItemInt,hWnd,id+7,ebx,ebx
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_COMMAND && wParam==id-6 && lParam==0        ; 'tree'
    mov ebx,offset _tree
    mov edi,id-6
    xor menutree,1                                
    .if menutree==0
      mov al,'-'
    .else
      mov al,'+'
    .endif
    mov byte ptr[ebx],al
    invoke GetMenu,hWnd
    mov esi,eax
    invoke ModifyMenu,esi,edi,MF_BYCOMMAND or MF_STRING,edi,ebx
    invoke DrawMenuBar,hWnd
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_COMMAND && wParam==id-9 && lParam==0        ; (ExtantMenu)
    mov eax,offset _exe    
    invoke ShellExecute,0,0,eax,0,0,SW_SHOWNORMAL
    .if eax<=32
      invoke MessageBox,0,offset _exe,0,MB_ICONERROR
    .endif
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_COMMAND && lParam!=0       ; 'IsMenu: 8 hex-symbols ->'
    mov ecx,wParam
    mov edx,ecx
    and ecx,0FFFFh
    shr edx,16
    .if ecx==id+5 && edx==EN_CHANGE
;      invoke SendDlgItemMessage,hWnd,ecx,WM_GETTEXT,9,addr buf
      invoke GetDlgItemText,hWnd,id+5,addr buf,9
      .if eax==8
        invoke htodw,addr buf
        mov ebx,eax
        invoke IsMenu,ebx
        .if eax!=0
          mov byte ptr[buffer],0
          invoke GetMenuTree,ebx,-1,addr buffer,menutree
          invoke SetDlgItemText,hWnd,id+4,addr buffer
          invoke FindWindow,offset _extmenu,0
          .if eax!=0
            mov edi,eax
            invoke GetClassLong,edi,GCW_ATOM
            invoke PostMessage,edi,eax,ebx,hWnd
          .endif
        .endif
        invoke Beep,6000,100
      .endif
    .endif
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_SIZE
    push id+1
    push id+2
    push id+4
    xor edi,edi
    .while edi<3
      pop eax
      invoke GetDlgItem,hWnd,eax
      mov ebx,eax
      invoke GetWindowRect_,ebx,addr rt
      invoke MapWindowPoints,0,hWnd,addr rt,2
      mov ecx,lParam
      and ecx,0FFFFh
      sub ecx,width_delta
      sub ecx,rt.left
      mov edx,rt.bottom
      sub edx,rt.top
      invoke SetWindowPos,ebx,0,0,0,ecx,edx,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
      inc edi
    .endw
    mov eax,TRUE
;-------------------------------------------------------------------------------------
  .elseif uMsg==WM_ENTERIDLE && wParam==MSGF_MENU
    inc enteridle
    invoke SetDlgItemInt,hWnd,id+7,enteridle,FALSE
    mov eax,FALSE
;-------------------------------------------------------------------------------------
	.else
    mov eax,FALSE
  .endif
  ret
DlgProc endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke DialogBoxParam,hinst,id,0,offset DlgProc,0
  invoke ExitProcess,eax
  invoke InitCommonControls  
end start

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;                                                                                ; INACTIVE --><-- GRAYED
; MF_ENABLED                  equ  0000h;                       ; MFT_ ; MFS_
; MF_STRING                   equ  0000h;
; MF_UNCHECKED                equ  0000h;                       ; MFS_
; MF_UNHILITE                 equ  0000h;                       ; MFS_
; MF_BYCOMMAND                equ  0000h
; MF_INSERT                   equ  0000h
; MF_GRAYED                   equ  0001h;                                         ; GRAYED
; MF_DISABLED                 equ  0002h;                       ; MFT_
; MF_BITMAP                   equ  0004h;
; MF_CHECKED                  equ  0008h;                       ; MFS_            ; CHECKED
; MF_POPUP                    equ  0010h;
; MF_MENUBARBREAK             equ  0020h;                       ; MFT_            ; MENUBARBREAK
; MF_MENUBREAK                equ  0040h;                       ; MFT_            ; MENUBREAK
; MF_HILITE                   equ  0080h; ; MF_END ; MF_CHANGE  ; MFS_
; MF_OWNERDRAW                equ  0100h; ; MF_APPEND           ; MFT_             
; MF_USECHECKBITMAPS          equ  0200h  ; MF_DELETE           ; MFT_RADIOCHECK             
; MF_BYPOSITION               equ  0400h
; MF_SEPARATOR                equ  0800h;                       ; MFT_            ; SEPARATOR       ; (not for menubar!)
; MF_DEFAULT                  equ  1000h  ; MF_REMOVE           ; MFS_
; MF_SYSMENU                  equ  2000h                        ; MFT_RIGHTORDER
; MF_HELP                     equ  4000h  ; MF_RIGHTJUSTIFY     ; MFT_            ; HELP
; MF_MOUSESELECT              equ  8000h
;
; MFS_GRAYED 				         equ  0003h  ; = MFS_DISABLED = (MF_GRAYED or MF_DISABLED)
; MFS_MASK 				           equ  108Bh 
;
;  <MENUITEMINFO_:>     (retrieves or sets:)        (replaced by:)
;  <fMask:>       
;   MIIM_TYPE            fType, dwTypeData            MIIM_BITMAP, MIIM_FTYPE, MIIM_STRING
;   MIIM_FTYPE           fType
;   MIIM_BITMAP          hbmpItem
;   MIIM_STRING          dwTypeData
;   MIIM_DATA            dwItemData
;   MIIM_CHECKMARKS      hbmpChecked, hbmpUnchecked
;   MIIM_ID              wID
;   MIIM_STATE           fState
;   MIIM_SUBMENU         hSubMenu
;   
;  <fType:>                                                                          MFT_BITMAP--><--MFT_STRING--><--MFT_SEPARATOR
;   MFT_BITMAP                                        MIIM_BITMAP, hbmpItem
;   MFT_STRING                                        MIIM_STRING
;   MFT_MENUBARBREAK
;   MFT_MENUBREAK
;   MFT_OWNERDRAW
;   MFT_RADIOCHECK
;   MFT_RIGHTORDER
;   MFT_RIGHTJUSTIFY    (valid only if the menu item is in a menu bar)
;   MFT_SEPARATOR       (valid only in a drop-down menu, submenu, or shortcut menu)
;
;  <fState:>
;   MFS_CHECKED
;   MFS_DEFAULT
;   MFS_DISABLED equ MFS_GRAYED
;   MFS_ENABLED
;   MFS_HILITE
;   MFS_UNCHECKED
;   MFS_UNHILITE
